/**
	Program to calculte the lambda matrix for
	a set of points.
	The algorithm uses the Graham Scan 

	Working with indexes
	Fraga, Jul 14, 2018
**/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


typedef struct {
	int x, y;
} POINT;

#define MYSIZE 10   // Up to 10 points it can calculate its lambda matrix
POINT Lpts[ MYSIZE ];

int do_work( char *name )
{
	FILE *fp;
	char line[64], *pchar;
	int i, n, x, y;
	int j, p;
	double ux, uy, vx, vy, d1, d2;
	double minimalDistance;

	if( (fp=fopen( name, "r"))==NULL ) {
		fprintf( stderr, "ERROR: opening %s file\n", name );
		return(1);	
	}
	for ( i=0;; ) {
		if( fgets( line, 64, fp ) == NULL ) break;

		pchar=line; 
		while( *pchar==' ' || *pchar=='\t' ) pchar++;
		if ( *pchar == '\n' || *pchar == '#' ) continue;

		if ( sscanf( pchar, "%d %d", &x, &y ) != 2 ) {
			fprintf( stderr, "ERROR: readind %s file\n", name );
			fclose ( fp );
			return (1);
		} 
		i++;
	}
	/** set the number of points **/
	n = i;
	if ( n > MYSIZE ) {
		fprintf( stderr, "Change MYSIZE in the sourse code and recompile it\n" );
		return 2;
	}
	// printf( "n = %d\n", n );

	/** reading data **/
	fseek( fp, 0, SEEK_SET );
	for ( i=0;; ) {
		if( fgets( line, 64, fp ) == NULL ) break;

		pchar=line; 
		while( *pchar==' ' || *pchar=='\t' ) pchar++;
		if ( *pchar == '\n' || *pchar == '#' ) continue;

		if ( sscanf( pchar, "%d %d", &x, &y ) != 2 ) {
			fprintf( stderr, "ERROR: readind %s file\n", name );
			fclose ( fp );
			return (1);
		} 
		Lpts[i].x = x;
		Lpts[i].y = y;
		i++;
	}
	fclose( fp );

	minimalDistance = 1e6;

	for( i=0; i<n-1; i++ ) {
		for( j=i+1; j<n; j++ ) {

			ux= Lpts[j].x - Lpts[i].x;
			uy= Lpts[j].y - Lpts[i].y;


			for (p = 0; p < n; p++) {
				if (p == i || p == j) {
					continue; 
				}   
				vx= Lpts[p].x - Lpts[j].x;
				vy= Lpts[p].y - Lpts[j].y;
				
				d1 = ux*vy - vx*uy;
				d2 = sqrt(d1*d1)/sqrt(ux*ux+uy*uy);
				
				if( d2 < minimalDistance){
					minimalDistance = d2;
				}   
			}   
		}
	}
	minimalDistance /= 2.0;

	printf("%lf ", minimalDistance );
	return 0;
}

int main( int argc, char *argv[] )
{
	char namein[64];

	if ( argc != 2 ) {
		fprintf( stderr, "Args: file_name\n" );
		return( 1 );
	}

	strncpy( namein, argv[1], 64 );
	if( do_work( namein ) ) {
		fprintf( stderr, "ERROR!\n" );
		return( 2 );
	}

	return 0;
}

