#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <float.h>
#include "matrix.h"
#include "pnm.h"

#define VT1 0.1
#define VT2 500
#define VT3 100000
#define N  7
#define FALSE 1
#define TRUE 0

static POINT borde[5000];
static int ddd[5000];
static float vvv[5000];
int objectNumber = 0;
int numMarcador = 0;

typedef struct punto {
	int x, y;
} PUNTO;

typedef struct puntod {
	double x, y;
} PUNTOD;

typedef struct {
	float area;
	float dx, dy; // Datos del centroide
	PUNTO pmin, pmax; // Datos de la caja envolvente
	int caracteristicas[8];
	PUNTO vertices[3];
} CENDATA;

typedef struct linea {
	double ox, oy, vx, vy;
} LINEA;

typedef struct vertice {
	double x, y;
} VERTICE;

typedef struct datos {
	POINT esquinas[4];
	int n;
	int ns[4];
	LINEA lin[4];
	VERTICE vestimados[4];
} DATOS;

void ordenaCuatroPuntos(POINT *v);
void copiaImagen(MATRIX *src, MATRIX *dst);
int calcula_borde_externo(MATRIX *G, int *val, DATOS *datos, float UPICOSFact);
void calculaLimites(MATRIX *E, int *val, int tono);
void calcula_bordes(MATRIX *G, int v);
void reestima_esquinas_triangulo(DATOS *datos);
double area(int x1, int y1, int x2, int y2, int x3, int y3);
double calculaDistanciaPuntos(int x1, int y1, int x2, int y2);

double area(int x1, int y1, int x2, int y2, int x3, int y3) {
	return (x2 - x1)*(y3 - y1)-(x3 - x1)*(y2 - y1);
}

double calculaDistanciaPuntos(int x1, int y1, int x2, int y2) {
	return sqrt((x1 - x2)*(x1 - x2)+(y1 - y2)*(y1 - y2));
}

void calculaVerticesTriangulo(MATRIX *T, DATOS *ves) {
	int i, j, tmp, vals[5], f0, c0, f1 = 0, c1 = 0, f2 = 0, c2 = 0, nBorde;
	double distMax, d;
	POINT inicial = borde[0];

	calculaLimites(T, vals, 0);
	//Encuentra los bordes externos e internos si es que existen. Los deja con valor 10 y lo interior en 8
	calcula_bordes(T, 0);
	//Encuentra un punto en el borde externo y lo sigue hasta volver al mismo. A los pixels
	//encontrados los marca con 20 y corresponden al borde externo.
	calcula_borde_externo(T, vals, ves, 0.8);
	//Obtenemos el numero de puntos que conforman el borde externo
	nBorde = ves->n;
	//Seleccionamos el primer punto como punto de inicio
	f0 = inicial.y;
	c0 = inicial.x;
	distMax = -999999;
	for (i = 0; i < nBorde; i++) {
		d = calculaDistanciaPuntos(f0, c0, borde[i].y, borde[i].x);
		if (d > distMax) {
			distMax = d;
			f1 = borde[i].y;
			c1 = borde[i].x;
			ves->ns[0] = i;
		}
	}
	//Looking for the second vertex
	distMax = -999999;
	for (i = 0; i < nBorde; i++) {
		d = calculaDistanciaPuntos(f1, c1, borde[i].y, borde[i].x);
		if (d > distMax) {
			distMax = d;
			f2 = borde[i].y;
			c2 = borde[i].x;
			ves->ns[1] = i;
		}
	}
	//looking for the third vertex
	distMax = -999999;
	for (i = 0; i < nBorde; i++) {
		d = area(c1, f1, c2, f2, borde[i].x, borde[i].y);
		if (d < 0) {
			d *= -1;
		}
		if (d > distMax) {
			distMax = d;
			ves->ns[2] = i;
		}
	}
	ves->esquinas[0].x = borde[ves->ns[0]].x;
	ves->esquinas[0].y = borde[ves->ns[0]].y;
	ves->esquinas[1].x = borde[ves->ns[1]].x;
	ves->esquinas[1].y = borde[ves->ns[1]].y;
	ves->esquinas[2].x = borde[ves->ns[2]].x;
	ves->esquinas[2].y = borde[ves->ns[2]].y;
	ves->n = nBorde;
	//Ordering vertices
	for (i = 0; i < 3; i++) {
		for (j = 0; j < 2; j++) {
			if (ves->ns[j] > ves->ns[j + 1]) {
				tmp = ves->ns[j];
				ves->ns[j] = ves->ns[j + 1];
				ves->ns[j + 1] = tmp;
			}
		}
	}
	/*printf("%d %d\n",ves->esquinas[0].x,ves->esquinas[0].y );
	printf("%d %d\n",ves->esquinas[1].x,ves->esquinas[1].y );
	printf("%d %d\n",ves->esquinas[2].x,ves->esquinas[2].y );*/
	//Estimate vertices at subpixel level
	reestima_esquinas_triangulo(ves);
}

void calculaLimites(MATRIX *E, int *val, int tono) {
	int i, j;
	byte ** data = (byte **) E->ptr;
	int xmin = 9999999, xmax = -99999999;
	int ymin = 9999999, ymax = -99999999;
	int area = 0;
	//Buscando el inicio
	for (i = 0; i < E->rows; i++) {
		for (j = 0; j < E->cols; j++) {
			if (data[i][j] == tono) {
				val[INICIOY] = i;
				val[INICIOX] = j;
				goto AQUI;
			}
		}
	}
AQUI:
	for (i = 0; i < E->rows; i++) {
		for (j = 0; j < E->cols; j++) {
			if (data[i][j] == tono) {
				if (i < xmin)xmin = i;
				if (i > xmax)xmax = i;
				if (j < ymin)ymin = j;
				if (i > ymax)ymax = j;
				area++;
			}
		}
	}
	val[AREA] = area;
	val[ANCHO] = xmax - xmin;
	val[LARGO] = ymax - ymin;
}

//Inverts image

void invertirImagen(MATRIX *IN) {
	int x, y, v;
	byte * pdata;
	for (y = 0; y < IN->rows; y++) {
		pdata = (byte *) IN->ptr[y];
		for (x = 0; x < IN->cols; x++) {
			if (*pdata == 255) {
				*pdata = 0;
			} else {
				*pdata = 255;
			}
			pdata++;
		}
	}
	// Un pixel alrededor del marco se pone en blanco
	// por un bug de la función que extrae los objetos
	pdata = (byte *) IN->ptr[0];
	for (x = 0; x < IN->cols; x++) *pdata++ = 255;

	v = IN->cols - 1;
	for (x = 1; x < IN->rows - 1; x++) {
		pdata = (byte *) IN->ptr[x];
		*pdata = 255;
		pdata[ v ] = 255;
	}

	pdata = (byte *) IN->ptr[ IN->rows - 1 ];
	for (x = 0; x < IN->cols; x++) *pdata++ = 255;
}
//Sets the image border

void marcarBorde(MATRIX *IN) {
	int x, v;
	byte * pdata;
	// Un pixel alrededor del marco se pone en blanco
	// por un bug de la función que extrae los objetos
	pdata = (byte *) IN->ptr[0];
	for (x = 0; x < IN->cols; x++) *pdata++ = 255;

	v = IN->cols - 1;
	for (x = 1; x < IN->rows - 1; x++) {
		pdata = (byte *) IN->ptr[x];
		*pdata = 255;
		pdata[ v ] = 255;
	}

	pdata = (byte *) IN->ptr[ IN->rows - 1 ];
	for (x = 0; x < IN->cols; x++) *pdata++ = 255;
}
//Erosion to the image

void erosion_3x3(MATRIX *IN, MATRIX *OUT) {

	int i, j, l, k;
	byte *ptrin, *ptrout;
	int val;

	for (i = 0; i < IN->rows; i++) {
		ptrout = (byte *) OUT->ptr[i];
		for (j = 0; j < IN->cols; j++) *ptrout++ = 0;
	}

	for (i = 0; i <= IN->rows - 3; i++) {
		ptrout = (byte *) OUT->ptr[i + 1] + 1;
		for (j = 0; j <= IN->cols - 3; j++) {
			val = 0xff;
			for (l = 0; l < 3; l++) {
				ptrin = (byte *) IN->ptr[i + l] + j;
				for (k = 0; k < 3; k++) val &= *ptrin++;
			}
			if (val) *ptrout = 255;
			ptrout++;
		}
	}
}
//Dilation to the image

void dilation_3x3(MATRIX *IN, MATRIX *OUT) {
	int i, j, l, k;
	byte *ptrin, *ptrout;
	int val;

	for (i = 0; i < IN->rows; i++) {
		ptrout = (byte *) OUT->ptr[i];
		for (j = 0; j < IN->cols; j++) *ptrout++ = 0;
	}

	for (i = 0; i <= IN->rows - 3; i++) {
		ptrout = (byte *) OUT->ptr[i + 1] + 1;
		for (j = 0; j <= IN->cols - 3; j++) {
			val = 0;
			for (l = 0; l < 3; l++) {
				ptrin = (byte *) IN->ptr[i + l] + j;
				for (k = 0; k < 3; k++) val |= *ptrin++;
			}
			if (val) *ptrout = val;
			ptrout++;
		}
	}
}

//finds border for an image

void calcula_bordes(MATRIX *G, int v) {
	int i, j;
	byte **bptr;

	bptr = (byte **) G->ptr;
	for (i = 0; i < G->rows; i++) {
		for (j = 0; j < G->cols; j++) {
			if (bptr[i][j] == v) {
				if (bptr[i][j - 1] <= 10 && bptr[i][j + 1] <= 10 && bptr[i - 1][j] <= 10 && bptr[i + 1][j] <= 10)
					bptr[i][j] = 8;
				else
					bptr[i][j] = 10;
			}
		}
	}
}
//Finds external border for an image

int calcula_borde_externo(MATRIX *G, int *val, DATOS *datos, float UPICOSFact) {
	int i, j, n = 0;
	byte *bptr;
	float cx, cy;
	float dx, dy, vmax, UPICOS;
	int suma, k;

	for (i = 0; i <= val[ANCHO]; i++) {
		bptr = (byte *) G->ptr[ val[INICIOY] + i ] + val[INICIOX];
		for (j = 0; j <= val[LARGO]; j++) {
			if (*bptr == 10) {
				// Suponemos que este punto es parte del borde externo
				// Seguimos todos los puntos consecutivos a este y lo
				// ponemos a valor igual a 20. Esos pixeles serán los
				// que formarán el "borde externo"
				n = franja(G, val[INICIOY] + i, val[INICIOX] + j, borde);
				goto FIN;
			}
			bptr++;
		}
	}
FIN:
	//El borde queda en la variable borde y tiene n elementos
	//Se calcula el centroide del borde
	cx = cy = 0.0;
	for (i = 0; i < n; i++) {
		cx += borde[i].x;
		cy += borde[i].y;
	}
	cx = cx / n;
	cy = cy / n;
	for (i = 0; i < n; i++) {
		dx = borde[i].x - cx;
		dy = borde[i].y - cy;
		//Se calcula la distancia al cuadrado de cada punto en el borde al centroide
		ddd[i] = (int) (dx * dx + dy * dy + 0.5);
	}
	k = 2;
	//Se calcula la suma de distancias al cuadrado
	suma = ddd[n - 2] + ddd[n - 1] + ddd[0] + ddd[1] + ddd[2];
	vvv[0] = ddd[0] - suma / 5.0;
	//Calcula una varianza para cada 5 elementos
	suma -= ddd[n - 2];
	suma += ddd[3];
	vvv[1] = ddd[1] - suma / 5.0;

	suma -= ddd[n - 1];
	suma += ddd[4];
	vvv[2] = ddd[2] - suma / 5.0;

	for (i = k + 1; i < n - k; i++) {
		suma -= ddd[i - 3];
		suma += ddd[i + 2];
		vvv[i] = ddd[i] - suma / 5.0;
	}

	i = n - k;
	suma -= ddd[i - 2];
	suma += ddd[0];
	vvv[i] = ddd[i] - suma / 5.0;

	i = n - k + 1; // i=n-1, el último para el actual valor de k
	suma -= ddd[i - 2];
	suma += ddd[1];
	vvv[i] = ddd[i] - suma / 5.0;

	vmax = 0;

	//Se encuentra la varianza maxima de las calculadas
	for (i = 0; i < n; i++) {
		if (vvv[i] > vmax) {
			vmax = vvv[i];
		}
	}

	UPICOS = UPICOSFact *vmax;

	j = 0;
	for (i = 0; i < n; i++)
		if (vvv[i] > UPICOS) {
			if (j < 5) {
				datos->esquinas[j].x = borde[i].x;
				datos->esquinas[j].y = borde[i].y;
				//Se llena ns como el indice en el borde que corresponde a una esquina
				//Se llena la esquina como el borde en la posicion ns
				datos->ns[j] = i;
			}
			j++;
		}
	datos->n = n;
	return ( j);
}
//Estimate triangles vertices at subpixel

void reestima_esquinas_triangulo(DATOS *datos) {
	int l, i, i0, i1, n;
	double mediax, mediay;
	double x, y, a, b, c;
	double vec[2], mat[4];
	double v, vmin, vmax;
	int lados = 3;

	// Se estiman los parámetros de las lineas que unen
	// los puntos 01, 12, 23 y 30 (cuatro líneas)
	// usando PCA
	for (l = 0; l < lados; l++) {
		// Se calcula la media de las líneas
		i0 = l;
		i1 = (l + 1) % lados;
		a = b = c = 0;
		if (datos->ns[i1] >= datos->ns[i0]) {
			n = datos->ns[i1] - datos->ns[i0] + 1;
			mediax = mediay = 0.0;
			for (i = datos->ns[i0]; i <= datos->ns[i1]; i++) {
				mediax += borde[i].x;
				mediay += borde[i].y;
			}
			mediax /= n;
			mediay /= n;
			for (i = datos->ns[i0]; i <= datos->ns[i1]; i++) {
				x = borde[i].x - mediax;
				y = borde[i].y - mediay;
				a += x*x;
				b += x*y;
				c += y*y;
			}
		} else {
			n = datos->n - datos->ns[i0] + datos->ns[i1] + 1;
			mediax = mediay = 0.0;
			for (i = 0; i <= datos->ns[i1]; i++) {
				mediax += borde[i].x;
				mediay += borde[i].y;
			}
			for (i = datos->ns[i0]; i < datos->n; i++) {
				mediax += borde[i].x;
				mediay += borde[i].y;
			}
			mediax /= n;
			mediay /= n;
			// printf("Media %d: %f %f\n", l, mediax, mediay );
			for (i = 0; i <= datos->ns[i1]; i++) {
				x = borde[i].x - mediax;
				y = borde[i].y - mediay;
				a += x*x;
				b += x*y;
				c += y*y;
			}
			for (i = datos->ns[i0]; i < datos->n; i++) {
				x = borde[i].x - mediax;
				y = borde[i].y - mediay;
				a += x*x;
				b += x*y;
				c += y*y;
			}
		}

		// La matriz es ahora
		// [ a b ]
		// [ b c ]

		// Calculamos los eigenvalores
		x = a - c;
		v = x * x + 4.0 * b*b;
		v = sqrt(v);

		vmin = ((c + a) - v) / 2.0;
		vmax = ((c + a) + v) / 2.0;

		double epsilon = 8.0 * DBL_EPSILON * vmax;

		mat[0] = a - vmin;
		mat[1] = b;
		mat[2] = b;
		mat[3] = c - vmin;

		v = mat[0] * mat[0] + mat[1] * mat[1];

		if (v <= epsilon) {
			vec[0] = 0.0;
			vec[1] = 1.0;
		} else {
			v = mat[2] * mat[2] + mat[3] * mat[3];

			if (v <= epsilon) {
				vec[0] = 1.0;
				vec[1] = 0.0;
			} else {
				v = sqrt(v);
				vec[0] = mat[1] / v;
				vec[1] = mat[3] / v;
			}
		}
		datos->lin[l].ox = mediax;
		datos->lin[l].oy = mediay;
		datos->lin[l].vx = vec[0];
		datos->lin[l].vy = vec[1];
	}

	// Se calculan las intersecciones de las líneas
	for (l = 0; l < lados; l++) {
		double o1, o2, d, ds1;

		i0 = l;
		i1 = (l + 1) % lados;

		o1 = datos->lin[i1].ox - datos->lin[i0].ox;
		o2 = datos->lin[i1].oy - datos->lin[i0].oy;

		d = datos->lin[i0].vx * datos->lin[i1].vy - datos->lin[i1].vx * datos->lin[i0].vy;
		ds1 = o1 * datos->lin[i1].vy - datos->lin[i1].vx * o2;

		ds1 /= d;

		datos->vestimados[l].x = datos->lin[i0].ox + ds1 * datos->lin[i0].vx;
		datos->vestimados[l].y = datos->lin[i0].oy + ds1 * datos->lin[i0].vy;
	}
}
//Inits image with a value

void inicializaImagen(MATRIX *IMG, int valor) {
	int x, y;
	byte *pdata;

	for (x = 0; x < IMG->rows; x++) {
		pdata = (byte*) IMG->ptr[x];
		for (y = 0; y < IMG->cols; y++) {
			*pdata++ = valor;
		}
	}
}
//Finds an initial point

int find_point_object(MATRIX *IN, int *x, int *y) {
	int i, j;
	byte *p;

	for (i = 2; i < IN->rows - 2; i++) {
		p = (byte *) IN->ptr[i];
		for (j = 2; j < IN->cols - 2; j++) {
			if (!p[j]) {
				*x = j;
				*y = i;
				return 1; /** Sucess! **/
			}
		}
	}
	return 0; /** Fault **/
}

//Finds an object and returns it

int extraeObjeto( MATRIX *IMG1, MATRIX *OBJ )
{
	byte *dataIN;
	byte *dataOUT;
	int i, j, p;
	int vals[5];
	p = find_point_object(IMG1, &j, &i);
	if (!p) {
		return -1;
	} else {
		p = left(IMG1, j, i);
		if (p >= 0) { /** Succesful!! **/
			push(p, i);
			do_fill(IMG1, vals);
			/** Borramos la imagen de salida **/
			inicializaImagen(OBJ, 255);
			/** Generamos una imagen con el objeto **/
			for (i = 0; i < IMG1->rows; i++) {
				dataIN = (byte *) IMG1->ptr[i];
				dataOUT = (byte *) OBJ->ptr[i];
				for (j = 0; j < IMG1->cols; j++) {
					if (*dataIN++ == 10)
						*dataOUT = 0;
					dataOUT++;
				}
			}
			/** Erasing object from source image**/
			for (i = 0; i < IMG1->rows; i++) {
				dataIN = (byte *) IMG1->ptr[i];
				for (j = 0; j < IMG1->cols; j++) {
					if (*dataIN == 10)
						*dataIN = 255;
					dataIN++;
				}
			}
		} else {
			clean_stack();
			fprintf(stderr, "There's not object!\n");
			return -1;
		}
	}
	return 0;
}
//Copy image

void copiaImagen(MATRIX *src, MATRIX *dst) {
	int i, j;
	byte *srcData, *dstData;

	for (i = 0; i < src->rows; i++) {
		srcData = (byte*) src->ptr[i];
		dstData = (byte*) dst->ptr[i];
		for (j = 0; j < src->cols; j++) {
			*dstData++ = *srcData++;
		}
	}
}
//Tries to separate contiguous but different objects

void  erosiona(MATRIX *G)
{
	//Erosionar el contenido
	MATRIX *S;
	MATRIX *TMP;
	MATRIX *OBJ;
	int pasadasErosion = 2;
	int pasada;
	S = matrix_allocate(G->rows, G->cols, 1);
	TMP = matrix_allocate(G->rows, G->cols, 1);
	OBJ = matrix_allocate(G->rows, G->cols, 1);

	copiaImagen(G, TMP);
	copiaImagen(G, S);
	copiaImagen(S, TMP);
	for (pasada = 0; pasada < pasadasErosion; pasada++) {
		erosion_3x3(TMP, S);
		copiaImagen(S, TMP);
	}
	for (pasada = 0; pasada < pasadasErosion; pasada++) {
		dilation_3x3(TMP, S);
		copiaImagen(S, TMP);
	}
	copiaImagen(TMP, G);
	matrix_free(S);
	matrix_free(TMP);
	matrix_free(OBJ);
}


//Prepare image to process
void preprocesing(MATRIX *I) {
	int min, max;
	int i, j, v;
	byte *bptr;
	int t1;

	//Thresholding
	min = 255;
	max = 0;
	for (i = 0; i < I->rows; i++) {
		bptr = (byte *) I->ptr[i];
		for (j = 0; j < I->cols; j++) {
			v = *bptr++;
			if (v < min) min = v;
			if (v > max) max = v;
		}
	}
	//Threshold value
	t1 = 220;
	// Se aplica el umbral global
	for (i = 0; i < I->rows; i++) {
		bptr = (byte *) I->ptr[i];
		for (j = 0; j < I->cols; j++) {
			if (*bptr > t1) *bptr = 255;
			else *bptr = 0;
			bptr++;
		}
	}
	//Image border
	bptr = (byte *) I->ptr[0];
	for (j = 0; j < I->cols; j++) *bptr++ = 255;
	v = I->cols - 1;
	for (j = 1; j < I->rows - 1; j++) {
		bptr = (byte *) I->ptr[j];
		*bptr = 255;
		bptr[ v ] = 255;
	}
	bptr = (byte *) I->ptr[ I->rows - 1 ];
	for (j = 0; j < I->cols; j++) *bptr++ = 255;
}

//Extract image pixels with a tone to the target image

void tone2Img(MATRIX *SRC, MATRIX *TRG, int tone) {
	int i, j;
	byte *iptr, *objectptr, g;
	for (i = 0; i < TRG->rows; i++) {
		objectptr = (byte *) SRC->ptr[i];
		iptr = (byte *) TRG->ptr[i];
		for (j = 0; j < TRG->cols; j++) {
			g = (byte) *objectptr;
			if ((byte) g == tone) {
				*iptr = 255;
			} 
			iptr++;
			objectptr++;
		}
	}
}

//process
int hace_trabajo( char *nombre )
{
	int i, j, g, t, found, toneColor = 20, p, encontrado, nv = 0, h, n[7], u = 0, triangles = 0;
	byte *iptr, *objectptr;
	MATRIX  *Gris, *OBJ, *SEGMENTED, *TMP, * Triangle[3];
	DATOS vertices;
	PUNTOD clusters[7];
	VERTICE *verti;

	Gris = read_pnm(nombre);
	if (Gris->type != 5) {
		fprintf(stderr, "ERROR, la imagen debe estar en formato RGB\n");
		return -1;
	}
	
	
	OBJ = matrix_allocate(Gris->rows, Gris->cols, 1);
	SEGMENTED = matrix_allocate(Gris->rows, Gris->cols, 1);
	TMP = matrix_allocate(Gris->rows, Gris->cols, 1);
	Triangle[0] = matrix_allocate(Gris->rows, Gris->cols, 1);
	Triangle[1] = matrix_allocate(Gris->rows, Gris->cols, 1);
	Triangle[2] = matrix_allocate(Gris->rows, Gris->cols, 1);
	inicializaImagen(SEGMENTED, 0);

	preprocesing(Gris);
	found = extraeObjeto(Gris, OBJ);
	invertirImagen(Gris);
	found = extraeObjeto(Gris, OBJ);
	invertirImagen(Gris);
	erosiona(Gris);
	invertirImagen(Gris);
	//Extracts objects, each object is set with a different tone
	do {
		found = extraeObjeto(Gris, OBJ);
		if (found)break;
		u++;
		for (i = 0; i < Gris->rows; i++) {
			objectptr = (byte *) OBJ->ptr[i];
			iptr = (byte *) SEGMENTED->ptr[i];
			for (j = 0; j < Gris->cols; j++) {
				g = (byte) (*objectptr);
				if ((byte) g == 0)
					*iptr = toneColor;
				iptr++;
				objectptr++;
			}
			}
		toneColor += 1;
	} while (found != -1);
	triangles = toneColor - 20;
	TMP = SEGMENTED;
	marcarBorde(TMP);
	
	for (h = 0; h < 7; h++)
		n[h] = 0;

	if (triangles == 3) {
		for (t = 0; t < 3; t++) {
			tone2Img(TMP, Triangle[t], 20 + t);
			invertirImagen(Triangle[t]);
			calculaVerticesTriangulo(Triangle[t], &vertices);
			verti = vertices.vestimados;
			for (p = 0; p < 3; p++) {
				encontrado = 0;
				for (h = 0; h < nv; h++) {
					if (calculaDistanciaPuntos(verti[p].x, verti[p].y, clusters[h].x, clusters[h].y) < 9) {
						clusters[h].x = clusters[h].x * n[h] + verti[p].x;
						clusters[h].y = clusters[h].y * n[h] + verti[p].y;
						n[h]++;
						// fprintf( stderr, "%d\n", n[h] );
						clusters[h].x = clusters[h].x / n[h];
						clusters[h].y = clusters[h].y / n[h];
						encontrado = 1;
						break;
					}
				}
				if (encontrado == 0) {
					clusters[nv].x = verti[p].x;
					clusters[nv].y = verti[p].y;
					nv++;
					if (nv == 7)
						break;
				}
			}
		}
	} else {
		printf("Error while decoding tag\n");
	}

	for (h = 0; h < 7; h++) {
		printf("%lf %lf ", clusters[h].x, clusters[h].y);
	}
	matrix_free(Gris);

	matrix_free(OBJ);
	matrix_free(SEGMENTED);
	matrix_free(Triangle[0]);
	matrix_free(Triangle[1]);
	matrix_free(Triangle[2]);
	return 0;
}

int main(int argc, char *argv[])
{
	char nombre[200];

	if (argc != 2) {
		fprintf(stderr, "Args: image.pgm\n");
		return -1;
	}
	strncpy(nombre, argv[1], 200);
	if (hace_trabajo(nombre) >= 0) {
	} else {
		fprintf(stderr, "ERROR: Something is wrong!!!\n");
		return (1);
	}
	return 0;
}

